/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	ScormLearnManager
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm;

import java.util.Hashtable;

import jp.co.ntt.lms.lo.LOException;
import jp.co.ntt.lms.lo.LearnData;
import jp.co.ntt.lms.lo.LearnManager;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.util.DebugLog;

/**
 * SCORM LO教材の学習／終了を管理するクラス。
 * @author T.Nishiki
 */
public class ScormLearnManager implements LearnManager{

	/**
	 * 学習開始処理を実行します。<br>
	 *
	 * @param params パラメータ。
	 * 以下の値が設定されていることを期待しています。<br>
	 * <table border="1">
	 * 	<tr>
	 * 		<th>キー</th>
	 * 		<th>値</th>
	 * 	</tr>
	 * 	<tr>
	 * 		<td>LoPropertyDef.LOID</td>
	 * 		<td>学習する教材のLOID</td>
	 * 	</tr>
	 * 	<tr>
	 * 		<td>LoPropertyDef.USERID</td>
	 * 		<td>学習するユーザID</td>
	 * 	</tr>
	 * </table><br>
	 * @param dataAccess データアクセスクラス。
	 * @return 学習開始で利用するLearnDataクラスオブジェクトを戻します。
	 * @throws LOException 処理中に例外が発生した場合。
	 * @see LearnManager#startLearn(Hashtable, DataAccess)
	 * @see jp.co.ntt.lms.lo.LearnData
	 */
	public Object startLearn(Hashtable params, DataAccess dataAccess)
		throws LOException {
		// メソッド開始ログ
		DebugLog.write(getClass(),
			"HEAD startLearn(" + params + "," + dataAccess + ")",
			DebugLog.ROW);

		LearnData learnData = new LearnData();
		// 教材URLを取得します
		ScormLoURLMaker urlMaker = new ScormLoURLMaker();
		String startLearnURL =
			urlMaker.makeStartLearnURL(params, dataAccess);

		ScormLoEnv scormEnv = new ScormLoEnv();
		String estimation = scormEnv.getEstimation();
		learnData.setLearnURL(startLearnURL);
		learnData.setEstimation(estimation);

		// メソッド終了ログ
		DebugLog.write(getClass(),
			"TAIL startLearn(" + params + "," + dataAccess + ")"
				+ " return " + learnData,
			DebugLog.ROW);


		return learnData;
	}

	/**
	 * 学習終了処理を実行します。<br>
	 *
	 * @param params パラメータ。
	 * @param dataAccess データアクセスクラス。
	 * @return nullを戻します。
	 * @throws LOException 処理中に例外が発生した場合。
	 * @see LearnManager#endLearn(Hashtable, DataAccess)
	 */
	public synchronized Object endLearn(
			Hashtable params, DataAccess dataAccess)
			throws LOException {

		// メソッド開始ログ
		DebugLog.write(getClass(),
			"HEAD endLearn(" + params + "," + dataAccess + ")",
			DebugLog.ROW);

		////////////////////////////////////////////////////////////////////////
		// データの取得
		ScormLoEndLearnData endLearnData = null;
		endLearnData = (ScormLoEndLearnData)params.get(
			ScormLoConstant.KEY_END_LEARN_DATA);
		////////////////////////////////////////////////////////////////////////
		// サーバ起動情報の削除
		String userID = endLearnData.getUserID();
		String loID = endLearnData.getLoID();
		ScormServerInfoControl serverInfoControl =
			ScormServerInfoControl.getInstance();
		serverInfoControl.decrementNumberOfUsers(userID, loID);
		////////////////////////////////////////////////////////////////////////
		// ログの挿入(終了理由が中止の場合、挿入しない）
		String reason = endLearnData.getReason();
		if (reason.equals(ScormLoConstant.PARAM_REASON_ABANDON) == false) {
			ScormLoLogControl logControl =
				new ScormLoLogControl();
			logControl.insertLog(dataAccess, endLearnData);
		}
		
//ADD start 2006.03.10 NTTR-an status伝播対応
		//LoServerにてStatusPropagarionにUserID/LOIDを引き渡すため
		//HashにUserID/LOIDを格納
		//本来であれば、LoPropertyDefをimplementsし、キーを定数で指定するべき
		params.put("USER", userID);
		params.put("LOID", loID);
//ADD end
		
		// メソッド終了ログ
		DebugLog.write(getClass(),
			"TAIL endLearn(" + params + "," + dataAccess + ")",
			DebugLog.ROW);
		return null;
	}
}
